## cantor 25.04.3

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13 FATAL_ERROR)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set (RELEASE_SERVICE_VERSION_MAJOR "25")
set (RELEASE_SERVICE_VERSION_MINOR "04")
set (RELEASE_SERVICE_VERSION_MICRO "3")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

project(cantor VERSION ${RELEASE_SERVICE_VERSION})

set(QT_MIN_VERSION "6.5.0")
set(KF_MIN_VERSION "6.3.0")

find_package(ECM ${KF_MIN_VERSION} REQUIRED CONFIG)
set(CMAKE_MODULE_PATH ${cantor_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} )

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddAppIcon)
include(KDEClangFormat)
include(GenerateExportHeader)
include(FeatureSummary)

set( SharedMimeInfo_MINIMUM_VERSION "1.3" ) #TODO: What is the minimum required version?
find_package(SharedMimeInfo ${SharedMimeInfo_MINIMUM_VERSION} REQUIRED)

option(BUILD_DOC "Whether to build the documentation" ON)

find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED
    Core
    Widgets
    PrintSupport
    Svg
    Xml
    Test
)

find_package(KF6 ${KF_MIN_VERSION} REQUIRED
    Config
    Crash
    Completion
    NewStuffCore
    NewStuff
    IconThemes
    TextEditor
    CoreAddons
    Archive
    Parts
    SyntaxHighlighting
    TextWidgets
    KIO
    XmlGui
    I18n
)

find_package(LibXml2 REQUIRED)
find_package(LibXslt REQUIRED)

option(ENABLE_EMBEDDED_DOCUMENTATION "Enable the emedded documentation depending on QtHelp and QtWebEngine" ON)
if (ENABLE_EMBEDDED_DOCUMENTATION)
    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED
        Help
        WebEngineCore
        WebEngineWidgets
    )
    add_definitions (-DHAVE_EMBEDDED_DOCUMENTATION)
endif ()

if (BUILD_DOC)
    find_package(KF6DocTools ${KF_MIN_VERSION})
    set_package_properties(KF6DocTools PROPERTIES
        DESCRIPTION "Tools to generate documentation"
        TYPE REQUIRED
    )
endif ()

find_package(Poppler "22.02.0" COMPONENTS Qt6)

option(USE_LIBSPECTRE "Use libspectre library" ON)

add_subdirectory(thirdparty)
# Need to set this here, because variable can't move from subdirectory (thirdparty) to upper cmake scope
set(Discount_FOUND TRUE)

if(NOT WIN32 AND USE_LIBSPECTRE)
    set_package_properties(LibSpectre PROPERTIES DESCRIPTION "A PostScript rendering library"
        URL "https://www.freedesktop.org/wiki/Software/libspectre/"
        TYPE OPTIONAL
        PURPOSE "Support for rendering EPS files in Cantor")

    find_package(LibSpectre)
    if(LIBSPECTRE_FOUND)
        set(WITH_EPS On)
    else(LIBSPECTRE_FOUND)
        set(WITH_EPS Off)
    endif(LIBSPECTRE_FOUND)

else()
    set(WITH_EPS Off)
endif()

#[[
find_package(Discount 2.2.0)
set_package_properties(Discount PROPERTIES DESCRIPTION "A C implementation of the Markdown markup language"
    URL "https://www.pell.portland.or.us/~orc/Code/discount/"
    TYPE OPTIONAL
    PURPOSE "Used for Markdown entries in Cantor")
]]#

add_definitions(
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060000
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060000
)
if (NOT WIN32)
    # Strict iterators can't be used on Windows, they lead to a link error
    # when application code iterates over a QVector<QPoint> for instance, unless
    # Qt itself was also built with strict iterators.
    # See example at https://bugreports.qt.io/browse/AUTOSUITE-946
    add_definitions(-DQT_STRICT_ITERATORS)
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")

   # both gcc & clang support it since the same version
   if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 5.0.0)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wzero-as-null-pointer-constant" )
   endif()
endif()

set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DQT_NO_DEBUG_OUTPUT")

kde_enable_exceptions()

# FIXME Looks like docbook on Windows isn't buildable at all, so it is temporarily disabled
if(NOT WIN32 AND BUILD_DOC)
    add_subdirectory(doc)
endif()
add_subdirectory(src)
add_subdirectory(icons)

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/Cantor")
configure_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/CantorConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/CantorConfig.cmake
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}/
    #PATH_VARS INCLUDE_INSTALL_DIR SYSCONFIG_INSTALL_DIR
)

ecm_setup_version(${RELEASE_SERVICE_VERSION}
    VARIABLE_PREFIX CANTOR
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/cantor_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/CantorConfigVersion.cmake"
)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/CantorConfig.cmake
          ${CMAKE_CURRENT_BINARY_DIR}/CantorConfigVersion.cmake
    DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    COMPONENT Devel
)

install(EXPORT CantorTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE CantorTargets.cmake
    NAMESPACE Cantor::
)


ki18n_install(po)
if (BUILD_DOC)
    kdoctools_install(po)
endif ()
install(FILES org.kde.cantor.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h *.c)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== debian/changelog ===
cantor (4:25.04.3-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Jul 2025 07:35:07 +0100

cantor (4:25.04.2-3ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.
    - Build depend on current version of analitza.
    - Apparmor profile to fix userns.

 -- Rik Mills <rikmills@kde.org>  Thu, 19 Jun 2025 06:05:06 +0100

cantor (4:25.04.2-1ubuntu2) questing; urgency=medium

  * Drop sagemath back to suggests for that backend.

 -- Rik Mills <rikmills@kde.org>  Sat, 07 Jun 2025 23:10:47 +0100

cantor (4:25.04.2-1ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.
    - Build depend on current version of analitza.
    - Apparmor profile to fix userns.

 -- Rik Mills <rikmills@kde.org>  Sat, 07 Jun 2025 17:20:55 +0100

cantor (4:25.04.2-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Jun 2025 11:36:46 +0100

=== debian/control ===
Source: cantor
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: appstream,
               cmake (>= 3.13~),
               debhelper-compat (= 13),
               dh-apparmor,
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               extra-cmake-modules (>= 6.3.0~),
               gettext,
               libanalitza-dev (>= 4:25.04.3~),
               libcups2-dev,
               libkf6archive-dev (>= 6.3.0~),
               libkf6completion-dev (>= 6.3.0~),
               libkf6config-dev (>= 6.3.0~),
               libkf6coreaddons-dev (>= 6.3.0~),
               libkf6crash-dev (>= 6.3.0~),
               libkf6doctools-dev (>= 6.3.0~),
               libkf6i18n-dev (>= 6.3.0~),
               libkf6iconthemes-dev (>= 6.3.0~),
               libkf6kio-dev (>= 6.3.0~),
               libkf6newstuff-dev (>= 6.3.0~),
               libkf6parts-dev (>= 6.3.0~),
               libkf6syntaxhighlighting-dev (>= 6.3.0~),
               libkf6texteditor-dev (>= 6.3.0~),
               libkf6textwidgets-dev (>= 6.3.0~),
               libkf6xmlgui-dev (>= 6.3.0~),
               libluajit-5.1-dev [amd64 arm64 armel armhf i386 mips64el riscv64 s390x],
               libpoppler-qt6-dev (>= 22.02.0~) [!i386],
               libpython3-dev,
               libqalculate-dev,
               libspectre-dev,
               libxml2-dev,
               libxslt1-dev,
               qt6-5compat-dev (>= 6.5.0~),
               qt6-base-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
               qt6-tools-dev (>= 6.5.0~),
               qt6-webengine-dev (>= 6.5.0~) [amd64 arm64 armhf i386],
               r-base-core,
               shared-mime-info (>= 1.3~),
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://cantor.kde.org/
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/cantor
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/cantor

Package: cantor
Architecture: any
Section: math
Depends: ${misc:Depends}, ${shlibs:Depends},
Recommends: cantor-backend-qalculate,
            texlive-plain-generic,
Suggests: cantor-backend-kalgebra,
          cantor-backend-lua [amd64 arm64 armel armhf i386 mips64el riscv64 s390x],
          cantor-backend-maxima,
          cantor-backend-octave,
          cantor-backend-python3,
          cantor-backend-r,
          cantor-backend-sage,
          cantor-backend-scilab [amd64 arm64 ppc64el s390x],
          apparmor
Description: interface for mathematical applications
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 Cantor supports various mathematical applications as backends (provided in
 external packages):
  * Maxima Computer Algebra System (cantor-backend-maxima)
  * R Project for Statistical Computing (cantor-backend-r)
  * Sage Mathematics Software (cantor-backend-sage)
  * Octave (cantor-backend-octave)
  * Python (cantor-backend-python3)
  * Scilab (cantor-backend-scilab)
  * Qalculate! (cantor-backend-qalculate)
  * Lua (cantor-backend-lua)
 .
 This package is part of the KDE education module.

Package: libcantorlibs28abi2
X-Debian-ABI: 2
X-CMake-Target: cantorlibs
Architecture: any
Multi-Arch: same
Section: libs
Depends: libcantorlibs-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: interface for mathematical applications - shared library
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the shared library for Cantor.
 .
 This package is part of the KDE education module.

Package: libcantorlibs-data
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends},
Replaces: libcantorlibs28 (<< 4:22.04.1-1~),
Breaks: libcantorlibs28 (<< 4:22.04.1-1~),
Description: interface for mathematical applications - data for shared library
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the data for the shared library for Cantor.
 .
 This package is part of the KDE education module.

Package: libcantor-dev
Architecture: any
Section: libdevel
Depends: libcantorlibs28abi2 (=  ${binary:Version}),
         ${misc:Depends},
Description: interface for mathematical applications - development files
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the development headers for Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-kalgebra
Architecture: any
Section: math
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: KAlgebra backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using KAlgebra
 (https://edu.kde.org/kalgebra) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-lua
Architecture: amd64 i386
Section: math
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Lua backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Lua language
 (https://www.lua.org) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-maxima
Architecture: any
Section: math
Depends: maxima, ${misc:Depends}, ${shlibs:Depends},
Description: Maxima backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Maxima Computer Algebra System
 (http://maxima.sourceforge.net) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-octave
Architecture: any
Section: math
Depends: octave, ${misc:Depends}, ${shlibs:Depends},
Description: Octave backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the GNU Octave language for
 numerical computations (https://www.octave.org/) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-python3
Architecture: any
Section: math
Depends: python3, ${misc:Depends}, ${shlibs:Depends},
Breaks: libcantor-pythonbackend (<< 4:20.04.2~),
Replaces: libcantor-pythonbackend (<< 4:20.04.2~),
Description: Python3 backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Python3 language
 (https://www.python.org/) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-qalculate
Architecture: any
Section: math
Depends: qalc,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Qalculate! backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Qalculate! calculator
 (https://qalculate.github.io/) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-r
Architecture: any
Section: math
Depends: r-base-core, ${misc:Depends}, ${shlibs:Depends},
Suggests: r-base-html,
Description: R backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the R Project for Statistical
 Computing (https://www.r-project.org) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-sage
Architecture: any
Section: math
Depends: ${misc:Depends},
         ${shlibs:Depends},
Suggests: sagemath,
Description: Sage backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Sage Mathematics Software
 (https://www.sagemath.org) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-scilab
Architecture: amd64 arm64 ppc64el s390x
Section: math
Depends: scilab-cli, ${misc:Depends}, ${shlibs:Depends},
Description: Scilab backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Scilab scientific software
 package for numerical computations (https://www.scilab.org) in Cantor.
 .
 This package is part of the KDE education module.

## cantor 25.07.80

=== src/backends/julia/CMakeLists.txt ===
include_directories(${JULIA_INCLUDE_DIRS})

find_package(Qt6 REQUIRED COMPONENTS DBus)
add_subdirectory(juliaserver)

set(JuliaBackend_SRCS
  juliabackend.cpp
  juliasession.cpp
  juliaexpression.cpp
  juliakeywords.cpp
  juliavariablemodel.cpp
  juliahighlighter.cpp
  juliaextensions.cpp
  juliacompletionobject.cpp
  juliasettingswidget.cpp
  ../backendsettingswidget.cpp
)

kconfig_add_kcfg_files(JuliaBackend_SRCS settings.kcfgc)
ki18n_wrap_ui(JuliaBackend_SRCS settings.ui)

add_backend(juliabackend ${JuliaBackend_SRCS})

target_link_libraries(cantor_juliabackend
  ${JULIA_LIBRARY}
  Qt6::DBus
  KF6::SyntaxHighlighting
)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_juliabackend cantor_help)
endif ()

if(BUILD_TESTING)
  add_executable(testjulia testjulia.cpp settings.cpp)
  add_test(NAME testjulia COMMAND testjulia)
  target_link_libraries(testjulia
    Qt6::Test
    cantorlibs
    cantortest
  )
endif(BUILD_TESTING)

install(FILES juliabackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
file(GLOB scripts "${CMAKE_CURRENT_SOURCE_DIR}/scripts/*.jl")
install(
  FILES ${scripts}
  DESTINATION ${KDE_INSTALL_DATADIR}/cantor/juliabackend/scripts
)

install(FILES graphic_packages.xml DESTINATION ${KDE_INSTALL_DATADIR}/cantor/julia)

=== debian/changelog ===
cantor (4:25.07.80-0ubuntu1) questing; urgency=medium

  * New upstream (beta) release (25.07.80)

 -- Rik Mills <rikmills@kde.org>  Sat, 12 Jul 2025 18:02:06 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                dh-sequence-pkgkde-symbolshelper,
                extra-cmake-modules (>= 6.3.0~),
                gettext,
-               libanalitza-dev (>= 4:25.04.3~),
+               libanalitza-dev (>= 4:25.07.80~),
                libcups2-dev,
                libkf6archive-dev (>= 6.3.0~),
                libkf6completion-dev (>= 6.3.0~),

## cantor 25.07.90

=== debian/changelog ===
cantor (4:25.07.90-0ubuntu1) questing; urgency=medium

  * New upstream (RC) release (25.07.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Jul 2025 17:27:10 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                dh-sequence-pkgkde-symbolshelper,
                extra-cmake-modules (>= 6.3.0~),
                gettext,
-               libanalitza-dev (>= 4:25.07.80~),
+               libanalitza-dev (>= 4:25.07.90~),
                libcups2-dev,
                libkf6archive-dev (>= 6.3.0~),
                libkf6completion-dev (>= 6.3.0~),

## cantor 25.08.0

=== debian/changelog ===
cantor (4:25.08.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 14 Aug 2025 11:48:18 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                dh-sequence-pkgkde-symbolshelper,
                extra-cmake-modules (>= 6.3.0~),
                gettext,
-               libanalitza-dev (>= 4:25.07.90~),
+               libanalitza-dev (>= 4:25.08.0~),
                libcups2-dev,
                libkf6archive-dev (>= 6.3.0~),
                libkf6completion-dev (>= 6.3.0~),

## cantor 25.08.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
-set (RELEASE_SERVICE_VERSION_MINOR "04")
-set (RELEASE_SERVICE_VERSION_MICRO "3")
+set (RELEASE_SERVICE_VERSION_MINOR "08")
+set (RELEASE_SERVICE_VERSION_MICRO "1")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(cantor VERSION ${RELEASE_SERVICE_VERSION})

=== src/CMakeLists.txt ===
#########################################################################
# Subdirectories
#########################################################################
add_subdirectory(lib)
add_subdirectory(scripteditor)

include_directories( lib ${CMAKE_CURRENT_BINARY_DIR}/lib)
if(BUILD_TESTING)
  include(ECMMarkAsTest)
  include_directories( lib/test )
endif(BUILD_TESTING)

add_subdirectory(backends)
add_subdirectory(assistants)
add_subdirectory(xslt)
add_subdirectory(panelplugins)


#build the config object in a separate library, shared between shell and part
kconfig_add_kcfg_files(config_SRCS settings.kcfgc)
add_library( cantor_config SHARED ${config_SRCS} )
target_link_libraries( cantor_config KF6::ConfigGui Qt6::Widgets )
generate_export_header( cantor_config BASE_NAME cantor_config )
install( TARGETS cantor_config ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

set(cantor_SRCS
   main.cpp
   cantor.cpp
   backendchoosedialog.cpp

   cantor.qrc
)

install(FILES cantor.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(cantor_SRCS settings.ui)
ki18n_wrap_ui(cantor_SRCS formating.ui)
ki18n_wrap_ui(cantor_SRCS backendchooser.ui)

file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/../icons/*-apps-cantor.png")
ecm_add_app_icon(cantor_SRCS ICONS ${ICONS_SRCS})
add_executable(cantor ${cantor_SRCS})

target_link_libraries(cantor KF6::Parts KF6::NewStuffWidgets KF6::ConfigCore KF6::CoreAddons KF6::ConfigGui
    KF6::Crash KF6::XmlGui cantorlibs cantor_config)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor Qt6::WebEngineCore)
endif()

########### install files ###############
install( TARGETS cantor ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )
install( FILES org.kde.cantor.desktop  DESTINATION ${KDE_INSTALL_APPDIR} )
install( FILES cantor.knsrc cantor-documentation.knsrc DESTINATION ${KDE_INSTALL_KNSRCDIR} )
install( FILES cantor.xml DESTINATION ${KDE_INSTALL_MIMEDIR} )
update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})

#########################################################################
# KPART SECTION
#########################################################################

set(cantor_PART_SRCS
   cantor_part.cpp
   worksheet.cpp
   worksheetview.cpp
   worksheetentry.cpp
   worksheettextitem.cpp
   worksheetimageitem.cpp
   commandentry.cpp
   textentry.cpp
   markdownentry.cpp
   pagebreakentry.cpp
   imageentry.cpp
   latexentry.cpp
   placeholderentry.cpp
   horizontalruleentry.cpp
   hierarchyentry.cpp
   worksheetcursor.cpp
   searchbar.cpp
   actionbar.cpp
   worksheettoolbutton.cpp
   imagesettingsdialog.cpp
   scripteditor/scripteditorwidget.cpp
   resultitem.cpp
   textresultitem.cpp
   imageresultitem.cpp
   animationresultitem.cpp
   loadedexpression.cpp
   animation.cpp
   mathrender.cpp
   mathrendertask.cpp
   worksheetcontrolitem.cpp

   cantor_part.qrc
 )

ki18n_wrap_ui(cantor_PART_SRCS imagesettings.ui)
ki18n_wrap_ui(cantor_PART_SRCS standardsearchbar.ui)
ki18n_wrap_ui(cantor_PART_SRCS extendedsearchbar.ui)

set(PATH_TO_CANTOR_BACKENDS "${KDE_INSTALL_FULL_PLUGINDIR}")

configure_file (config-cantor.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-cantor.h )

kcoreaddons_add_plugin(cantorpart
    SOURCES ${cantor_PART_SRCS}
    INSTALL_NAMESPACE "kf6/parts")

add_dependencies(cantorpart discount_project)
target_include_directories(cantorpart PRIVATE ${CMAKE_BINARY_DIR}/thirdparty/src/discount_project)
target_link_libraries(cantorpart KF6::Parts KF6::NewStuffWidgets KF6::TextEditor
                     KF6::KIOCore KF6::KIOFileWidgets KF6::KIOWidgets Discount::Lib
                     Qt6::PrintSupport cantorlibs cantor_config LibXslt::LibXslt LibXml2::LibXml2)

if(BUILD_TESTING)
    add_subdirectory(test)
endif(BUILD_TESTING)

=== src/assistants/advancedplot/CMakeLists.txt ===
set( AdvancedPlotAssistant_SRCS
     advancedplotassistant.cpp
     advancedplotassistant.qrc
)

ki18n_wrap_ui(AdvancedPlotAssistant_SRCS advancedplotdialog.ui directivecontainer.ui)

add_assistant(advancedplotassistant ${AdvancedPlotAssistant_SRCS})

=== src/assistants/plot2d/CMakeLists.txt ===
set( Plot2dAssistant_SRCS
     plot2dassistant.cpp
     plot2dassistant.qrc
)

ki18n_wrap_ui(Plot2dAssistant_SRCS plot2ddlg.ui)

add_assistant(plot2dassistant ${Plot2dAssistant_SRCS})

=== src/assistants/plot3d/CMakeLists.txt ===
set( Plot3dAssistant_SRCS
     plot3dassistant.cpp
     plot3dassistant.qrc
)

ki18n_wrap_ui(Plot3dAssistant_SRCS plot3ddlg.ui)

add_assistant(plot3dassistant ${Plot3dAssistant_SRCS})

=== src/assistants/linearalgebra/creatematrix/CMakeLists.txt ===
set( CreateMatrixAssistant_SRCS
     creatematrixassistant.cpp
     creatematrixdlg.cpp
     creatematrixassistant.qrc
)

ki18n_wrap_ui(CreateMatrixAssistant_SRCS creatematrixdlg.ui)

add_assistant(creatematrixassistant ${CreateMatrixAssistant_SRCS})

=== src/assistants/linearalgebra/eigenvectors/CMakeLists.txt ===
set( EigenVectorsAssistant_SRCS
     eigenvectorsassistant.cpp
     eigenvectorsassistant.qrc
)

ki18n_wrap_ui(EigenVectorsAssistant_SRCS eigenvectorsdlg.ui)

add_assistant(eigenvectorsassistant ${EigenVectorsAssistant_SRCS})

=== debian/changelog ===
cantor (4:25.08.1-0ubuntu1) questing; urgency=medium

  * New upstream release (25.08.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 11 Sep 2025 07:04:45 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                dh-sequence-pkgkde-symbolshelper,
                extra-cmake-modules (>= 6.3.0~),
                gettext,
-               libanalitza-dev (>= 4:25.08.0~),
+               libanalitza-dev (>= 4:25.08.1~),
                libcups2-dev,
                libkf6archive-dev (>= 6.3.0~),
                libkf6completion-dev (>= 6.3.0~),

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/stable/release-service/([\d.]+)/src/@PACKAGE@-([\d.]+)\.tar\.xz

## cantor 25.08.1+p24.04+vstable+git20251001.1513

=== debian/changelog ===
cantor (4:25.08.1+p24.04+vstable+git20251001.1513-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 01 Oct 2025 15:13:44 +0000

cantor (4:25.08.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 09 Sep 2025 09:21:35 +0000

cantor (4:25.08.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 14 Aug 2025 12:56:41 +0000

cantor (4:25.04.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 05 Jul 2025 11:34:48 +0000

cantor (4:25.04.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 05 Jun 2025 10:50:06 +0000

cantor (4:25.04.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 08 May 2025 04:40:59 +0000

cantor (4:25.04.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 17 Apr 2025 11:26:04 +0000

cantor (4:24.12.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 08 Mar 2025 13:55:09 +0000

cantor (4:24.12.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 07 Feb 2025 14:55:31 +0000

cantor (4:24.12.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 09 Jan 2025 19:47:55 +0000

cantor (4:24.12.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 11 Dec 2024 18:45:13 +0000

cantor (4:24.08.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 07 Nov 2024 10:45:55 +0000

cantor (4:24.08.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 14 Oct 2024 21:17:46 +0000

cantor (4:24.08.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 22 Sep 2024 07:57:09 +0000

cantor (4:24.08.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 19 Jun 2024 10:08:36 +0000

cantor (4:24.05.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 11 Apr 2024 11:44:30 +0000

cantor (4:24.02.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 20 Mar 2024 17:11:14 +0000

cantor (4:24.02.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 24 Feb 2024 03:57:57 +0000

cantor (4:23.08.5-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 19 Feb 2024 14:53:21 +0000

cantor (4:23.08.4-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 06 Dec 2023 16:34:41 +0000

cantor (4:23.08.3-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 09 Nov 2023 10:12:43 +0000

cantor (4:23.08.2-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 11 Oct 2023 17:11:13 +0000

cantor (4:23.08.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 13 Sep 2023 17:12:00 +0000

cantor (4:23.08.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 24 Aug 2023 09:40:34 +0000

cantor (4:23.04.3-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 07 Jun 2023 05:23:26 +0000

cantor (4:22.12.3-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 02 Mar 2023 12:55:07 +0000

cantor (4:22.12.2-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 01 Feb 2023 17:25:33 +0000

cantor (4:22.12.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 05 Jan 2023 16:01:19 +0000

cantor (4:22.12.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 07 Dec 2022 12:08:11 +0000

cantor (4:22.08.3-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 03 Nov 2022 09:29:48 +0000

cantor (4:22.08.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 09 Sep 2022 12:21:10 +0000

cantor (4:22.08.0-0.1neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 18 Aug 2022 09:31:11 +0000

cantor (4:22.04.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 07 Jul 2022 12:21:09 +0000

cantor (4:22.04.2-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 07 Jun 2022 20:43:54 +0000

cantor (4:22.04.1-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 10 May 2022 13:37:12 +0000

cantor (4:22.04.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 18 Apr 2022 12:52:01 +0000

cantor (4:21.12.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 03 Mar 2022 11:02:50 +0000

cantor (4:21.12.2-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 03 Feb 2022 11:01:24 +0000

cantor (4:21.12.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 06 Dec 2021 23:12:53 +0000

cantor (4:21.08.2-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 06 Oct 2021 11:33:18 +0000

cantor (4:21.08.1-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 01 Sep 2021 09:30:54 +0000

cantor (4:21.08.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 10 Aug 2021 12:27:15 +0000

cantor (4:21.04.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 12 Jul 2021 11:47:58 +0000

cantor (4:21.04.2-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 11 Jun 2021 08:19:54 +0000

cantor (4:21.04.1-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 13 May 2021 08:50:55 +0000

cantor (4:21.04.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 19 Apr 2021 10:19:10 +0000

cantor (4:20.12.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 03 Mar 2021 12:55:27 +0000



## cantor 25.08.1+p24.04+vstable+git20251002.0402

=== debian/changelog ===
cantor (4:25.08.1+p24.04+vstable+git20251002.0402-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 02 Oct 2025 04:02:47 +0000

## cantor 25.08.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
 set (RELEASE_SERVICE_VERSION_MINOR "08")
-set (RELEASE_SERVICE_VERSION_MICRO "1")
+set (RELEASE_SERVICE_VERSION_MICRO "2")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(cantor VERSION ${RELEASE_SERVICE_VERSION})

=== src/assistants/CMakeLists.txt ===
function(add_assistant name)

    kcoreaddons_add_plugin("cantor_${name}"
        SOURCES ${ARGN}
        INSTALL_NAMESPACE "cantor_plugins/assistants")

    target_link_libraries("cantor_${name}"
        cantorlibs)

endfunction()


add_subdirectory(solve)
add_subdirectory(integrate)
add_subdirectory(differentiate)
add_subdirectory(linearalgebra)
add_subdirectory(runscript)
add_subdirectory(plot2d)
add_subdirectory(plot3d)
add_subdirectory(advancedplot)
add_subdirectory(importpackage)

=== src/lib/CMakeLists.txt ===
if(LIBSPECTRE_FOUND)
   include_directories(${LIBSPECTRE_INCLUDE_DIR})
endif(LIBSPECTRE_FOUND)

set( cantor_LIB_SRCS
  session.cpp
  expression.cpp
  backend.cpp
  result.cpp
  textresult.cpp
  imageresult.cpp
  mimeresult.cpp
  epsresult.cpp
  latexresult.cpp
  latexrenderer.cpp
  renderer.cpp
  helpresult.cpp
  animationresult.cpp
  htmlresult.cpp
  extension.cpp
  assistant.cpp
  completionobject.cpp
  syntaxhelpobject.cpp
  defaulthighlighter.cpp
  defaultvariablemodel.cpp
  panelplugin.cpp
  panelpluginhandler.cpp
  worksheetaccess.cpp
  directives/plotdirectives.cpp
  jupyterutils.cpp
  graphicpackage.cpp
)

Set( cantor_LIB_HDRS
  cantor_macros.h
  #base classes
  backend.h
  session.h
  expression.h
  extension.h
  syntaxhelpobject.h
  completionobject.h
  #results
  animationresult.h
  epsresult.h
  helpresult.h
  imageresult.h
  latexresult.h
  renderer.h
  result.h
  textresult.h
  mimeresult.h
  htmlresult.h
  #helper classes
  defaulthighlighter.h
  defaultvariablemodel.h
  worksheetaccess.h
  jupyterutils.h
  graphicpackage.h
  # plugin classes
  panelplugin.h
  panelpluginhandler.h
)

ki18n_wrap_ui(cantor_LIB_SRCS directives/axisrange.ui directives/plottitle.ui)

kconfig_add_kcfg_files(cantor_LIB_SRCS cantor_libs_settings.kcfgc)
install(FILES cantor_libs.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

configure_file (config-cantorlib.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-cantorlib.h )

add_library( cantorlibs  SHARED ${cantor_LIB_SRCS} )
generate_export_header(cantorlibs BASE_NAME cantor)

target_link_libraries( cantorlibs
  KF6::Completion
  KF6::IconThemes
  KF6::KIOCore
  KF6::KIOFileWidgets
  KF6::KIOWidgets
  KF6::Archive
  KF6::ConfigCore
  KF6::ConfigGui
  KF6::I18n
  KF6::XmlGui
  Qt6::Xml
  Qt6::Svg
  Poppler::Qt6
)

if(LIBSPECTRE_FOUND)
    target_link_libraries(cantorlibs ${LIBSPECTRE_LIBRARY})
endif(LIBSPECTRE_FOUND)

set (CANTORLIBS_SOVERSION 28)
set_target_properties( cantorlibs PROPERTIES VERSION ${RELEASE_SERVICE_VERSION} SOVERSION ${CANTORLIBS_SOVERSION})

ecm_setup_version(${RELEASE_SERVICE_VERSION}
    VARIABLE_PREFIX CANTOR
    SOVERSION ${CANTORLIBS_SOVERSION}
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/cantorlibs_version.h
)

install( TARGETS cantorlibs EXPORT CantorTargets  ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(
  FILES
    ${cantor_LIB_HDRS}
    ${CMAKE_CURRENT_BINARY_DIR}/cantor_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/cantorlibs_version.h
  DESTINATION ${KDE_INSTALL_INCLUDEDIR}/cantor
  COMPONENT Devel
)

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== src/xslt/CMakeLists.txt ===
install( FILES latex.xsl DESTINATION ${KDE_INSTALL_DATADIR}/cantor/xslt )

=== src/assistants/solve/CMakeLists.txt ===
set( SolveAssistant_SRCS
     solveassistant.cpp
     solveassistant.qrc
)

ki18n_wrap_ui(SolveAssistant_SRCS solvedlg.ui)

add_assistant(solveassistant ${SolveAssistant_SRCS})

=== src/backends/kalgebra/CMakeLists.txt ===
set( KAlgebraBackend_SRCS
  kalgebrasyntaxhelpobject.cpp
  kalgebrabackend.cpp
  kalgebrasession.cpp
  kalgebraexpression.cpp
  kalgebracompletionobject.cpp
  kalgebraextensions.cpp
)

remove_definitions(-DQT_NO_CAST_TO_ASCII)
remove_definitions(-DQT_NO_CAST_FROM_ASCII)

kconfig_add_kcfg_files(KAlgebraBackend_SRCS settings.kcfgc)
install(FILES kalgebrabackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(KAlgebraBackend_SRCS settings.ui)

add_backend(kalgebrabackend ${KAlgebraBackend_SRCS})

target_link_libraries( cantor_kalgebrabackend KF6::Analitza KF6::AnalitzaGui )

install( FILES cantor_kalgebra.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

=== src/backends/octave/CMakeLists.txt ===
set( OctaveBackend_SRCS
  octavebackend.cpp
  octavesession.cpp
  octaveexpression.cpp
  octaveextensions.cpp
  octavehighlighter.cpp
  octavekeywords.cpp
  octavecompletionobject.cpp
  octavesyntaxhelpobject.cpp
  octavevariablemodel.cpp
  octavesettingswidget.cpp
  ../backendsettingswidget.cpp
)

add_subdirectory(scripts)

set(DEFAULT_PLOT_FORMAT "png")

configure_file(octavebackend.kcfg.in ${CMAKE_CURRENT_BINARY_DIR}/octavebackend.kcfg)

kconfig_add_kcfg_files(OctaveBackend_SRCS settings.kcfgc)
install(FILES octavebackend.kcfg.in DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(OctaveBackend_SRCS settings.ui)

add_backend(octavebackend ${OctaveBackend_SRCS})


target_link_libraries(cantor_octavebackend
  KF6::KIOCore
  KF6::ConfigCore
  KF6::ConfigGui
  KF6::SyntaxHighlighting

)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_octavebackend cantor_help)
endif ()

if(BUILD_TESTING)
  add_executable(testoctave testoctave.cpp ${OctaveBackend_SRCS})
  add_test(NAME testoctave COMMAND testoctave)
  target_link_libraries( testoctave
    Qt6::Test
    KF6::SyntaxHighlighting
    cantorlibs
    cantortest
  )
  if (ENABLE_EMBEDDED_DOCUMENTATION)
      target_link_libraries(testoctave cantor_help)
  endif ()
endif()


install(FILES cantor_octave.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

install(FILES graphic_packages.xml DESTINATION ${KDE_INSTALL_DATADIR}/cantor/octave)

=== src/backends/sage/CMakeLists.txt ===
set( SageBackend_SRCS
  sagebackend.cpp
  sagesession.cpp
  sageexpression.cpp
  sageextensions.cpp
  sagekeywords.cpp
  sagehighlighter.cpp
  sagecompletionobject.cpp
  sagesettingswidget.cpp
  ../backendsettingswidget.cpp
)

kconfig_add_kcfg_files(SageBackend_SRCS settings.kcfgc)
install(FILES sagebackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(SageBackend_SRCS settings.ui)

add_backend(sagebackend ${SageBackend_SRCS})

target_link_libraries( cantor_sagebackend KF6::SyntaxHighlighting)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_sagebackend cantor_help)
endif ()

if(BUILD_TESTING)
  add_executable( testsage testsage.cpp)
  add_test(NAME testsage COMMAND testsage)
  target_link_libraries( testsage
    Qt6::Test
    cantorlibs
    cantortest
  )
endif()

install(FILES cantor_sage.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR})

=== thirdparty/discount-2.2.6-patched/msvc/Makefile ===
# NMAKE Makefile to build Discount with Visual C++
CFLAGS	=	/nologo /MP /MDd /EHa /Zi \
			/D_CRT_SECURE_NO_DEPRECATE /D_CRT_NONSTDC_NO_DEPRECATE /D_SCL_SECURE_NO_WARNINGS \
			/I.
LIBOBJ	=	mkdio.obj markdown.obj dumptree.obj generate.obj \
			resource.obj docheader.obj version.obj toc.obj css.obj \
			xml.obj Csio.obj xmlpage.obj basename.obj emmatch.obj \
			github_flavoured.obj setup.obj tags.obj html5.obj flags.obj
MKDLIB	= libmarkdown.lib
PGMS=markdown
SAMPLE_PGMS=mkd2html makepage
# modules that markdown, makepage, mkd2html, &tc use
COMMON=pgm_options.obj gethopt.obj

VERSION = 2.2.6

default:	all

all:	$(MKDLIB) $(PGMS) $(SAMPLE_PGMS)

$(MKDLIB):	$(LIBOBJ)
	if exist $(MKDLIB) del $(MKDLIB)
	lib /out:$(MKDLIB) $(LIBOBJ)

config.h: msvc/config.h.vc
	copy /Y msvc\config.h.vc config.h

version.c: version.c.in
	powershell.exe -Command "(gc version.c.in) -replace '@TABSTOP@', 'TABSTOP' | Out-File version.c"

version.obj: version.c config.h
	$(CC) $(CFLAGS) -DBRANCH="" -DVERSION=\"$(VERSION)\" /c version.c

mkdio.h: mkdio.h.in
	powershell.exe -Command "(gc mkdio.h.in) -replace '@DWORD@', 'unsigned long' | Out-File mkdio.h"

mkdio.obj: mkdio.h

tags.obj: tags.c cstring.h tags.h blocktags

pgm_options.obj: pgm_options.c mkdio.h config.h
	$(CC) $(CFLAGS) /c pgm_options.c

mktags: mktags.obj
	$(CC) $(CFLAGS) mktags.obj

blocktags: mktags
	.\mktags.exe > blocktags

mkd2html:  mkd2html.obj $(MKDLIB) mkdio.h gethopt.h gethopt.obj
	$(CC) $(CFLAGS) $(LFLAGS) mkd2html.obj gethopt.obj $(MKDLIB)

markdown: main.obj $(COMMON) $(MKDLIB)
	$(CC) $(CFLAGS) $(LFLAGS) /Femarkdown main.obj $(COMMON) $(MKDLIB)

makepage:  makepage.c $(COMMON) $(MKDLIB) mkdio.h
	$(CC) $(CFLAGS) $(LFLAGS) makepage.c $(COMMON) $(MKDLIB)

clean:
	-del config.h blocktags mkdio.h version.c
	-del *.obj *.lib
	-del *.pdb *.exp
	-del *.ilk *.exe

=== debian/changelog ===
cantor (4:25.08.2-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.08.2)

 -- Rik Mills <rikmills@kde.org>  Fri, 17 Oct 2025 11:38:17 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                dh-sequence-pkgkde-symbolshelper,
                extra-cmake-modules (>= 6.3.0~),
                gettext,
-               libanalitza-dev (>= 4:25.08.1~),
+               libanalitza-dev (>= 4:25.08.2~),
                libcups2-dev,
                libkf6archive-dev (>= 6.3.0~),
                libkf6completion-dev (>= 6.3.0~),

## cantor 25.08.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
 set (RELEASE_SERVICE_VERSION_MINOR "08")
-set (RELEASE_SERVICE_VERSION_MICRO "2")
+set (RELEASE_SERVICE_VERSION_MICRO "3")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(cantor VERSION ${RELEASE_SERVICE_VERSION})

=== src/backends/R/CMakeLists.txt ===
include_directories(${R_INCLUDEDIR})
LINK_DIRECTORIES(${R_SHAREDLIBDIR})

if(NOT WIN32)
# rserver is using RInterface.h which is Unix only
# see https://colinfay.me/writing-r-extensions/linking-guis-and-other-front-ends-to-r.html
add_subdirectory(rserver)
endif()

set( RBackend_SRCS
  rbackend.cpp
  rsession.cpp
  rexpression.cpp
  rextensions.cpp
  rcompletionobject.cpp
  rhighlighter.cpp
  rkeywords.cpp
  rsettingswidget.cpp
  rvariablemodel.cpp
  ../backendsettingswidget.cpp
)

kconfig_add_kcfg_files(RBackend_SRCS rserver/settings.kcfgc)

set(network_xml rserver/org.kde.Cantor.R.xml)
find_package(Qt6 REQUIRED COMPONENTS DBus)
qt_add_dbus_interface(RBackend_SRCS ${network_xml} rserver_interface )

ki18n_wrap_ui(RBackend_SRCS settings.ui)

add_backend(rbackend ${RBackend_SRCS})

set_target_properties( cantor_rbackend PROPERTIES INSTALL_RPATH_USE_LINK_PATH false)

target_link_libraries( cantor_rbackend ${R_USED_LIBS} Qt6::DBus KF6::SyntaxHighlighting)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_rbackend cantor_help)
endif ()

if(MSVC)
# When compiling with MSVC, we have to create a .lib file for R.dll, first
find_package(Python3 COMPONENTS Interpreter REQUIRED)
add_custom_target(R_lib COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/GenLibFile.py ${R_R_LIBRARY} ${CMAKE_BINARY_DIR} ${CMAKE_SYSTEM_PROCESSOR}
                        COMMENT "Generate .lib file for R.dll")
add_dependencies(cantor_rbackend R_lib)
endif(MSVC)

if(BUILD_TESTING)
  add_executable( testr testr.cpp)
  add_test(NAME testr COMMAND testr)
  ecm_mark_as_test(testr)
  target_link_libraries( testr
    Qt6::Test
    cantorlibs
    cantortest
  )
endif(BUILD_TESTING)

install( FILES cantor_r.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

=== src/panelplugins/filebrowserpanel/CMakeLists.txt ===
set(FileBrowserPanelPlugin_SRCS
     filebrowserpanelplugin.cpp
)

add_panel(filebrowserpanelplugin ${FileBrowserPanelPlugin_SRCS})

target_link_libraries(cantor_filebrowserpanelplugin KF6::Parts)

=== src/panelplugins/helppanel/CMakeLists.txt ===
set( HelpPanelPlugin_SRCS
     helppanelplugin.cpp
)

add_panel(helppanelplugin ${HelpPanelPlugin_SRCS})

target_link_libraries(cantor_helppanelplugin
    KF6::TextWidgets)

=== src/backends/julia/juliaserver/CMakeLists.txt ===
add_definitions(-DJULIA_ENABLE_THREADING=1)

set(JuliaServer_SRCS
    juliaserver.cpp
    main.cpp
)
add_executable(cantor_juliaserver ${JuliaServer_SRCS})

target_link_libraries(cantor_juliaserver
    ${JULIA_LIBRARY}
    ${JULIA_INTERNAL_LIBRARY}
    Qt6::Widgets
    Qt6::DBus
)

install(TARGETS cantor_juliaserver ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
cantor (4:25.08.3-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Nov 2025 15:20:15 +0000

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                dh-sequence-pkgkde-symbolshelper,
                extra-cmake-modules (>= 6.3.0~),
                gettext,
-               libanalitza-dev (>= 4:25.08.2~),
+               libanalitza-dev (>= 4:25.08.3~),
                libcups2-dev,
                libkf6archive-dev (>= 6.3.0~),
                libkf6completion-dev (>= 6.3.0~),

## cantor 25.08.3+p24.04+vunstable+git20251208.0312

=== debian/changelog ===
cantor (4:25.08.3+p24.04+vunstable+git20251208.0312-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 08 Dec 2025 03:13:08 +0000

cantor (4:25.08.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 07 Nov 2025 00:37:26 +1000

cantor (4:25.08.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 10 Oct 2025 03:59:43 +0000
